using System;
using System.Threading;
using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;

namespace Mono.Debugger.Callbacks
{
	public class ThreadManager
	{
		[MethodImplAttribute(MethodImplOptions.InternalCall)]
		public extern static void AcquireGlobalThreadLock ();

		[MethodImplAttribute(MethodImplOptions.InternalCall)]
		public extern static void ReleaseGlobalThreadLock ();
	}

	class TestThreadLock
	{
		static void ThreadFunc ()
		{
			while (true) {
				Console.WriteLine ("Test!");
				Thread.Sleep (500);
			}
		}

		static void Main ()
		{
			Thread thread = new Thread (new ThreadStart (ThreadFunc));
			thread.Start ();

			ThreadManager.AcquireGlobalThreadLock ();
			ThreadManager.ReleaseGlobalThreadLock ();
		}
	}
}
